/* $Id: String0.java,v 1.2 2012/02/12 08:01:04 mit Exp $
/* String0.java v0.1 <-String.java */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class String0 extends Applet 
    implements Runnable, AdjustmentListener, ActionListener
{
    private Thread th;
    private Scrollbar scrA;
    private Button btStop;  // stop
    private Button btGO;    // go
    private Panel PS;

    static int NMax = 64;      // ʬ
    static double GB = 1d;     // ο
    static double R = 1/8d;    // R=D*dt/(dz^2)
    static double ALP = R*R;
    static double BET = 2d*(1-ALP);
    private static final long serialVersionUID = 1L;

    boolean SW;	
    int W;
    int H;
    int H2;
    int DOT;
    int SFT;
    int SP = NMax/8;         // Ǹ
    int Time = 0;
    int Now = 0;
    int[] OLD = {2,0,1};
    double DW;
    double DH;
    double[][] TMP = new double[NMax+1][OLD.length];

    Graphics gi;
    Image ig;
    DecimalFormat df1;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

	PS = new Panel();
	PS.setLayout(new GridLayout(2,2,0,0));

	scrA = new Scrollbar(Scrollbar.HORIZONTAL, SP, 1, 1, NMax);  
	scrA.addAdjustmentListener(this);
	PS.add(scrA);

	PS.add(new Label(": Plucking Point"));

        btGO = new Button("GO");
        PS.add(btGO);
        btGO.addActionListener(this);

        btStop = new Button("Stop");
        PS.add(btStop);
        btStop.addActionListener(this);

	add(PS, "South");

	inits();
    }
    public void inits() {                // ν
	for (int j = 0; j < OLD.length; j ++) {
	    for (int i = 0; i <= NMax; i++) {
		TMP[i][j] = (i < SP) ? GB/SP*i :
		    GB-GB/(NMax-SP)*(i-SP);
	    }
	    TMP[0][j] = 0;
	    TMP[NMax][j] = 0;
	}
    }
    public String dform(double n){
        return df1.format((float)n);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
	SP = scrA.getValue();
	inits();    
	repaint();
    }
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == btStop)      // stop
            SW = true;
        else if (e.getSource() == btGO) { // go
            SW = false;
            th = null;
            start();
        }
    }
    //
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = H/2;
	ig = createImage(W, H);
        gi = ig.getGraphics();

	DOT = 2;
	SFT = DOT/2;
	DW = W/(double)(NMax+1); // δֳ
	DH = H/3.0;              // ܿ

	if (th == null) {
	    th = new Thread(this);
	    th.start();
	}
    }
    public Dimension getCanvasD() {
        Dimension ds = PS.getSize();
        Dimension da = getSize();
        int cw = da.width;
        int ch = da.height-ds.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    //
    public void run() {
	while(!SW) {
	    try {
		Time++;
		if (Time > Integer.MAX_VALUE)
		    Time = 0;

		repaint();
		th.sleep(5);
	    } 
	    catch (InterruptedException e) {
		System.out.println(e);
	    }
	}
    }
    public void stop() {
	if (th != null)
	    th = null;
    }	
    //
    public void update( Graphics g) {
	paint(g);
    }
    public void paint(Graphics g) {
	paintI();
        g.drawImage(ig, 0, 0, this);
    }
    public void paintI() {
	gi.setColor(Color.black);
	gi.fillRect(0, 0, W, H);

	disp_line(gi);

	for (int i = 1; i < NMax; i++) {
	    TMP[i][OLD[OLD[Now]]] = ALP*(TMP[i-1][Now]+TMP[i+1][Now])+ 
		BET*TMP[i][Now]-TMP[i][OLD[Now]];
	}

	gi.setColor(Color.green);
	for (int i = 0; i <= NMax; i++)
	    gi.fillOval((int)(DW*i+SFT), (int)(H2-DH*TMP[i][OLD[Now]]), DOT, DOT);

	Now = OLD[OLD[Now]];
    }
    public void disp_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2+SFT, W, H2+SFT);

	g.setColor(Color.red);
	g.drawString("Plucking Point: 1/"+
		     dform(NMax/(double)SP), 10, 20);
    }
}


